#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>

#define SIZE 1048576

double walltime()
{
	static struct timeval t;
	gettimeofday(&t, NULL);
	return (t.tv_sec + 1e-6 * t.tv_usec);
}

int main()
{
	int i;

	float* a = (float*) malloc(SIZE*sizeof(float));
	float* b = (float*) malloc(SIZE*sizeof(float));
	float* c = (float*) malloc(SIZE*sizeof(float));

	for(i=0; i<SIZE; i++) {
		a[i] = 1.0f * i;
		b[i] = 2.0f * i;
		c[i] = 0.0f;
	}

	double runtime;
	double start = walltime();

	for (i = 0; i < SIZE; i++) {
		c[i] = a[i] * b[i];
	}

	runtime = walltime() - start;
	printf("Runtime: %8.3f ms\n", runtime*1e3);

	//for(i=0; i<SIZE; i++)
	//	printf("%f + %f = %f\n", a[i], b[i], c[i]);

	free(a);
	free(b);
	free(c);
}

