/*
Copyright (c) 2013-2014, Shodruky Rhyammer
Copyright (c) 2014, Trygve Aaberge
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

	Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.

	Redistributions in binary form must reproduce the above copyright notice, this
	list of conditions and the following disclaimer in the documentation and/or
	other materials provided with the distribution.

	Neither the name of the copyright holders nor the names of its
	contributors may be used to endorse or promote products derived from
	this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Originally code for Mandelbrot computation, licenced as stated above, from:
https://github.com/parallella/parallella-examples/tree/master/mandelbrot
Used as basis and modified for this Game of Life implementation.
*/


#include <stdint.h>

#define FRAMES 100
#define ALIGN8 8
#define CORES 16
#define ROWS 4
#define COLS 4
#define XRES 180
#define YRES 180

typedef struct __attribute__((aligned(ALIGN8))) {
	uint32_t value;
	uint32_t coreid;
	uint32_t finished;
} msg_dev2host_t;

typedef struct __attribute__((aligned(ALIGN8))) {
	uint32_t value;
} msg_host2dev_t;

typedef struct __attribute__((aligned(ALIGN8))) {
	uint32_t xres;
	uint32_t yres;
} info_t;

typedef struct {
	msg_host2dev_t msg_h2d[CORES];
	msg_dev2host_t msg_d2h[CORES];
	info_t info;
	uint32_t pixels[CORES][YRES][XRES];
} msg_block_t;

